/***************************************************************************
 *   Copyright (c) by Sascha Hlusiak, 2005                                 *
 *   Sascha Hlusiak <contact@saschahlusiak.de>                             *
 *                                                                         *
 *   A working !!! GLFont::class                                           *
 *   QFont Intl Support                                                    *
 *   X11 Qt Antialiasing support                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _GL_FONT_
#define _GL_FONT_

#include <GL/gl.h>
#include <qgl.h>

class QFont;
class QFontMetrics;
class QRect;

class GLFont
{
public:
    GLFont(QFont vfont);
    ~GLFont();

    void init();
//  void renderChar(double x,double y,int chr);
    void renderText(double x,double y,QString text,bool fade,double maxw);
    void renderText(QRect r,Qt::AlignmentFlags align,QString text,bool fade);

    int height;
private:
    QFont font;
    QFontMetrics metrics;
    GLuint textures[65536];     // Damn unicode
    GLuint list_base;
    bool shadow;

    void checkText(QString text);
    QImage adjustAlphaBuffer(QImage img);
};

#endif
